summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--media-libs/mesa/files/0002-radeong-opencl-rename-target-from-r600-to-r600-amd-n.patch26
-rw-r--r--media-libs/mesa/files/0003-clover-fix-building-and-add-standart-locations-for-l.patch38
-rw-r--r--media-libs/mesa/files/eselect-mesa.conf.8.138
-rw-r--r--media-libs/mesa/files/glx_ro_text_segm.patch28
-rw-r--r--media-libs/mesa/files/mesa-8.1-dont-require-llvm-for-r300.patch25
-rw-r--r--media-libs/mesa/mesa-9999.ebuild456
6 files changed, 611 insertions, 0 deletions
diff --git a/media-libs/mesa/files/0002-radeong-opencl-rename-target-from-r600-to-r600-amd-n.patch b/media-libs/mesa/files/0002-radeong-opencl-rename-target-from-r600-to-r600-amd-n.patch
new file mode 100644
index 0000000..2eebc9c
--- /dev/null
+++ b/media-libs/mesa/files/0002-radeong-opencl-rename-target-from-r600-to-r600-amd-n.patch
@@ -0,0 +1,26 @@
+From 7c4d0a88c45acedfd47eba93646bf5ea7435472c Mon Sep 17 00:00:00 2001
+From: Alexey Shvetsov <alexxy@gentoo.org>
+Date: Sun, 3 Jun 2012 13:52:00 +0400
+Subject: [PATCH 2/3] radeong/opencl rename target from r600-- to
+ r600-amd-none
+
+---
+ src/gallium/drivers/r600/r600_pipe.c | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/src/gallium/drivers/r600/r600_pipe.c b/src/gallium/drivers/r600/r600_pipe.c
+index e0ee823..790afcc 100644
+--- a/src/gallium/drivers/r600/r600_pipe.c
++++ b/src/gallium/drivers/r600/r600_pipe.c
+@@ -582,7 +582,7 @@ static int r600_get_compute_param(struct pipe_screen *screen,
+ switch (param) {
+ case PIPE_COMPUTE_CAP_IR_TARGET:
+ if (ret) {
+- strcpy(ret, "r600--");
++ strcpy(ret, "r600-amd-none");
+ }
+ return 7 * sizeof(char);
+
+--
+1.7.10.2
+
diff --git a/media-libs/mesa/files/0003-clover-fix-building-and-add-standart-locations-for-l.patch b/media-libs/mesa/files/0003-clover-fix-building-and-add-standart-locations-for-l.patch
new file mode 100644
index 0000000..2b18806
--- /dev/null
+++ b/media-libs/mesa/files/0003-clover-fix-building-and-add-standart-locations-for-l.patch
@@ -0,0 +1,38 @@
+From 3d4239edd2c89d3b67aef11786f0846fba96d718 Mon Sep 17 00:00:00 2001
+From: Alexey Shvetsov <alexxy@gentoo.org>
+Date: Sun, 3 Jun 2012 04:35:51 +0400
+Subject: [PATCH 3/3] clover fix building and add standart locations for
+ libclc
+
+---
+ src/gallium/state_trackers/clover/llvm/invocation.cpp | 4 ++--
+ src/gallium/targets/opencl/Makefile.am | 1 +
+ 2 files changed, 3 insertions(+), 2 deletions(-)
+
+diff --git a/src/gallium/state_trackers/clover/llvm/invocation.cpp b/src/gallium/state_trackers/clover/llvm/invocation.cpp
+index 27276bc..78c8670 100644
+--- a/src/gallium/state_trackers/clover/llvm/invocation.cpp
++++ b/src/gallium/state_trackers/clover/llvm/invocation.cpp
+@@ -107,7 +107,7 @@ namespace {
+ c.getHeaderSearchOpts().ResourceDir = CLANG_RESOURCE_DIR;
+
+ // Add libclc generic search path
+- c.getHeaderSearchOpts().AddPath(LIBCLC_PATH "/generic/include/",
++ c.getHeaderSearchOpts().AddPath(LIBCLC_PATH "/include/",
+ clang::frontend::Angled,
+ false, false, false);
+
+@@ -142,7 +142,7 @@ namespace {
+ llvm::Linker linker("clover", mod);
+
+ // Link the kernel with libclc
+- linker.LinkInFile(llvm::sys::Path(LIBCLC_PATH + triple + "/lib/builtins.bc"), isNative);
++ linker.LinkInFile(llvm::sys::Path(LIBCLC_PATH + ("/lib/clc/" + triple + "/builtins.bc")), isNative);
+ mod = linker.releaseModule();
+
+ // Run link time optimizations
+diff --git a/src/gallium/targets/opencl/Makefile.am b/src/gallium/targets/opencl/Makefile.am
+index d55b21e..4c89e36 100644
+--
+1.7.10.2
+
diff --git a/media-libs/mesa/files/eselect-mesa.conf.8.1 b/media-libs/mesa/files/eselect-mesa.conf.8.1
new file mode 100644
index 0000000..63a21aa
--- /dev/null
+++ b/media-libs/mesa/files/eselect-mesa.conf.8.1
@@ -0,0 +1,38 @@
+# mesa classic/gallium implementations in this release
+
+# Syntax description:
+# * MESA_IMPLEMENTATIONS contains a space-delimited list of switchable
+# classic/gallium implementations.
+# * MESA_DRIVERS is an associative array, for each member "foo" of
+# MESA_IMPLEMENTATIONS it contains the following elements:
+# foo,description - Human-readable description of the driver
+# foo,classicdriver - Filename of the classic driver
+# foo,galliumdriver - Filename of the gallium driver
+# foo,default - which of classic or gallium is chosen by default
+
+MESA_IMPLEMENTATIONS="i915 i965 r300 r600 sw"
+declare -A MESA_DRIVERS || die "MESA_DRIVERS already in environment and not associative."
+
+MESA_DRIVERS[i915,description]="i915 (Intel 915, 945)"
+MESA_DRIVERS[i915,classicdriver]="i915_dri.so"
+MESA_DRIVERS[i915,galliumdriver]="i915g_dri.so"
+MESA_DRIVERS[i915,default]="gallium"
+
+MESA_DRIVERS[i965,description]="i965 (Intel 965, G/Q3x, G/Q4x)"
+MESA_DRIVERS[i965,classicdriver]="i965_dri.so"
+MESA_DRIVERS[i965,default]="classic"
+
+MESA_DRIVERS[r300,description]="r300 (Radeon R300-R500)"
+MESA_DRIVERS[r300,classicdriver]="r300_dri.so"
+MESA_DRIVERS[r300,galliumdriver]="r300g_dri.so"
+MESA_DRIVERS[r300,default]="gallium"
+
+MESA_DRIVERS[r600,description]="r600 (Radeon R600-R700, Evergreen, Northern Islands)"
+MESA_DRIVERS[r600,classicdriver]="r600_dri.so"
+MESA_DRIVERS[r600,galliumdriver]="r600g_dri.so"
+MESA_DRIVERS[r600,default]="gallium"
+
+MESA_DRIVERS[sw,description]="sw (Software renderer)"
+MESA_DRIVERS[sw,classicdriver]="swrast_dri.so"
+MESA_DRIVERS[sw,galliumdriver]="swrastg_dri.so"
+MESA_DRIVERS[sw,default]="gallium"
diff --git a/media-libs/mesa/files/glx_ro_text_segm.patch b/media-libs/mesa/files/glx_ro_text_segm.patch
new file mode 100644
index 0000000..495b7dc
--- /dev/null
+++ b/media-libs/mesa/files/glx_ro_text_segm.patch
@@ -0,0 +1,28 @@
+2011-02-09 Jeremy Huddleston <jeremyhu@freedesktop.org
+
+ #240956
+ * configure.ac add support to enable readonly test segment on x86
+
+--- configure.ac.orig 2008-11-17 23:19:38.000000000 +0100
++++ configure.ac 2008-11-17 23:20:17.000000000 +0100
+@@ -499,6 +499,20 @@
+ enable_xcb=no
+ fi
+
++
++dnl readonly text segment on x86 hardened platforms
++AC_ARG_ENABLE([glx_rts],
++ [AS_HELP_STRING([--enable-glx-rts],
++ [on x86, use a readonly text segment for libGL @<:@default=disabled@:>@])],
++ [enable_glx_rts="$enableval"],
++ [enable_glx_rts=no])
++if test "x$enable_glx_rts" = xyes; then
++ DEFINES="$DEFINES -DGLX_X86_READONLY_TEXT"
++else
++ enable_glx_rts=no
++fi
++
++
+ dnl
+ dnl libGL configuration per driver
+ dnl
diff --git a/media-libs/mesa/files/mesa-8.1-dont-require-llvm-for-r300.patch b/media-libs/mesa/files/mesa-8.1-dont-require-llvm-for-r300.patch
new file mode 100644
index 0000000..9fe7e32
--- /dev/null
+++ b/media-libs/mesa/files/mesa-8.1-dont-require-llvm-for-r300.patch
@@ -0,0 +1,25 @@
+--- a/configure.ac 2012-05-12 11:50:09.786970584 +0200
++++ b/configure.ac 2012-05-12 12:00:00.770582272 +0200
+@@ -1922,14 +1922,6 @@
+ fi
+ }
+
+-gallium_require_llvm() {
+- if test "x$MESA_LLVM" = x0; then
+- case "$host_cpu" in
+- i*86|x86_64) AC_MSG_ERROR([LLVM is required to build $1 on x86 and x86_64]);;
+- esac
+- fi
+-}
+-
+ gallium_require_drm_loader() {
+ if test "x$enable_gallium_loader" = xyes; then
+ PKG_CHECK_MODULES([LIBUDEV], [libudev], [],
+@@ -1962,7 +1954,6 @@
+ ;;
+ xr300)
+ PKG_CHECK_MODULES([RADEON], [libdrm_radeon >= $LIBDRM_RADEON_REQUIRED])
+- gallium_require_llvm "Gallium R300"
+ GALLIUM_DRIVERS_DIRS="$GALLIUM_DRIVERS_DIRS r300"
+ gallium_check_st "radeon/drm" "dri-r300" "xorg-r300" "" "xvmc-r300" "vdpau-r300" "va-r300"
+ ;;
diff --git a/media-libs/mesa/mesa-9999.ebuild b/media-libs/mesa/mesa-9999.ebuild
new file mode 100644
index 0000000..520303b
--- /dev/null
+++ b/media-libs/mesa/mesa-9999.ebuild
@@ -0,0 +1,456 @@
+# Copyright 1999-2012 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: $
+
+EAPI=4
+
+EGIT_REPO_URI="git://anongit.freedesktop.org/mesa/mesa"
+
+if [[ ${PV} = 9999* ]]; then
+ GIT_ECLASS="git-2"
+ EXPERIMENTAL="true"
+fi
+
+inherit base autotools multilib flag-o-matic toolchain-funcs ${GIT_ECLASS}
+
+OPENGL_DIR="xorg-x11"
+
+MY_PN="${PN/m/M}"
+MY_P="${MY_PN}-${PV/_/-}"
+MY_SRC_P="${MY_PN}Lib-${PV/_/-}"
+
+FOLDER="${PV/_rc*/}"
+
+DESCRIPTION="OpenGL-like graphic library for Linux"
+HOMEPAGE="http://mesa3d.sourceforge.net/"
+
+#SRC_PATCHES="mirror://gentoo/${P}-gentoo-patches-01.tar.bz2"
+if [[ $PV = 9999* ]]; then
+ SRC_URI="${SRC_PATCHES}"
+else
+ SRC_URI="ftp://ftp.freedesktop.org/pub/mesa/${FOLDER}/${MY_SRC_P}.tar.bz2
+ ${SRC_PATCHES}"
+fi
+
+# The code is MIT/X11.
+# GLES[2]/gl[2]{,ext,platform}.h are SGI-B-2.0
+LICENSE="MIT SGI-B-2.0"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~sh ~sparc ~x86 ~amd64-fbsd ~x86-fbsd ~x86-freebsd ~amd64-linux ~ia64-linux ~x86-linux ~sparc-solaris ~x64-solaris ~x86-solaris"
+
+INTEL_CARDS="i915 i965 intel"
+RADEON_CARDS="r100 r200 r300 r600 radeon radeonsi"
+VIDEO_CARDS="${INTEL_CARDS} ${RADEON_CARDS} nouveau vmware"
+for card in ${VIDEO_CARDS}; do
+ IUSE_VIDEO_CARDS+=" video_cards_${card}"
+done
+
+IUSE="${IUSE_VIDEO_CARDS}
+ bindist +classic debug +egl g3dvl +gallium gbm gles1 gles2 +llvm +nptl
+ opencl openvg osmesa pax_kernel pic r600-llvm-compiler selinux +shared-glapi vdpau
+ wayland xvmc xa xorg kernel_FreeBSD"
+
+REQUIRED_USE="
+ g3dvl? ( gallium )
+ llvm? ( gallium )
+ openvg? ( egl gallium )
+ opencl? ( gallium r600-llvm-compiler )
+ gbm? ( shared-glapi )
+ g3dvl? ( || ( vdpau xvmc ) )
+ vdpau? ( g3dvl )
+ r600-llvm-compiler? ( gallium llvm || ( video_cards_r600 video_cards_radeon ) )
+ xa? ( gallium )
+ xorg? ( gallium )
+ xvmc? ( g3dvl )
+ video_cards_intel? ( || ( classic gallium ) )
+ video_cards_i915? ( || ( classic gallium ) )
+ video_cards_i965? ( classic )
+ video_cards_nouveau? ( || ( classic gallium ) )
+ video_cards_radeon? ( || ( classic gallium ) )
+ video_cards_r100? ( classic )
+ video_cards_r200? ( classic )
+ video_cards_r300? ( gallium )
+ video_cards_r600? ( gallium )
+ video_cards_radeonsi? ( gallium llvm )
+ video_cards_vmware? ( gallium )
+"
+
+LIBDRM_DEPSTRING=">=x11-libs/libdrm-2.4.39"
+# keep correct libdrm and dri2proto dep
+# keep blocks in rdepend for binpkg
+RDEPEND="
+ !<x11-base/xorg-server-1.7
+ !<=x11-proto/xf86driproto-2.0.3
+ classic? ( app-admin/eselect-mesa )
+ gallium? ( app-admin/eselect-mesa )
+ >=app-admin/eselect-opengl-1.2.6
+ dev-libs/expat
+ gbm? (
+ sys-fs/udev
+ x11-libs/libdrm[libkms]
+ )
+ >=x11-libs/libX11-1.3.99.901
+ x11-libs/libXdamage
+ x11-libs/libXext
+ x11-libs/libXxf86vm
+ >=x11-libs/libxcb-1.8.1
+ opencl? (
+ app-admin/eselect-opencl
+ dev-libs/libclc
+ )
+ vdpau? ( >=x11-libs/libvdpau-0.4.1 )
+ wayland? ( dev-libs/wayland )
+ xorg? (
+ x11-base/xorg-server
+ x11-libs/libdrm[libkms]
+ )
+ xvmc? ( >=x11-libs/libXvMC-1.0.6 )
+ ${LIBDRM_DEPSTRING}[video_cards_nouveau?,video_cards_vmware?]
+"
+for card in ${INTEL_CARDS}; do
+ RDEPEND="${RDEPEND}
+ video_cards_${card}? ( ${LIBDRM_DEPSTRING}[video_cards_intel] )
+ "
+done
+
+for card in ${RADEON_CARDS}; do
+ RDEPEND="${RDEPEND}
+ video_cards_${card}? ( ${LIBDRM_DEPSTRING}[video_cards_radeon] )
+ "
+done
+
+DEPEND="${RDEPEND}
+ llvm? (
+ >=sys-devel/llvm-2.9
+ r600-llvm-compiler? ( >=sys-devel/llvm-3.1 )
+ video_cards_radeonsi? ( >=sys-devel/llvm-3.1 )
+ )
+ opencl? (
+ >=sys-devel/clang-3.1
+ >=sys-devel/gcc-4.6
+ )
+ =dev-lang/python-2*
+ dev-libs/libxml2[python]
+ sys-devel/bison
+ sys-devel/flex
+ virtual/pkgconfig
+ x11-misc/makedepend
+ >=x11-proto/dri2proto-2.6
+ >=x11-proto/glproto-1.4.15-r1
+ >=x11-proto/xextproto-7.0.99.1
+ x11-proto/xf86driproto
+ x11-proto/xf86vidmodeproto
+"
+
+S="${WORKDIR}/${MY_P}"
+
+PATCHES=(
+ "${FILESDIR}/0002-radeong-opencl-rename-target-from-r600-to-r600-amd-n.patch"
+ "${FILESDIR}/0003-clover-fix-building-and-add-standart-locations-for-l.patch"
+ )
+
+# It is slow without texrels, if someone wants slow
+# mesa without texrels +pic use is worth the shot
+QA_EXECSTACK="usr/lib*/opengl/xorg-x11/lib/libGL.so*"
+QA_WX_LOAD="usr/lib*/opengl/xorg-x11/lib/libGL.so*"
+
+# Think about: ggi, fbcon, no-X configs
+
+pkg_setup() {
+ # workaround toc-issue wrt #386545
+ use ppc64 && append-flags -mminimal-toc
+}
+
+src_unpack() {
+ default
+ if [[ ${PV} = 9999* ]]; then
+ git-2_src_unpack
+ fi
+}
+
+src_prepare() {
+ # apply patches
+ if [[ ${PV} != 9999* && -n ${SRC_PATCHES} ]]; then
+ EPATCH_FORCE="yes" \
+ EPATCH_SOURCE="${WORKDIR}/patches" \
+ EPATCH_SUFFIX="patch" \
+ epatch
+ fi
+
+ # relax the requirement that r300 must have llvm, bug 380303
+ epatch "${FILESDIR}"/${PN}-8.1-dont-require-llvm-for-r300.patch
+
+ # fix for hardened pax_kernel, bug 240956
+ [[ ${PV} != 9999* ]] && epatch "${FILESDIR}"/glx_ro_text_segm.patch
+
+ # Solaris needs some recent POSIX stuff in our case
+ if [[ ${CHOST} == *-solaris* ]] ; then
+ sed -i -e "s/-DSVR4/-D_POSIX_C_SOURCE=200112L/" configure.ac || die
+ fi
+
+ # Tests fail against python-3, bug #407887
+ sed -i 's|/usr/bin/env python|/usr/bin/env python2|' src/glsl/tests/compare_ir || die
+
+ base_src_prepare
+
+ eautoreconf
+}
+
+src_configure() {
+ local myconf
+
+ if use classic; then
+ # Configurable DRI drivers
+ driver_enable swrast
+
+ # Intel code
+ driver_enable video_cards_i915 i915
+ driver_enable video_cards_i965 i965
+ if ! use video_cards_i915 && \
+ ! use video_cards_i965; then
+ driver_enable video_cards_intel i915 i965
+ fi
+
+ # Nouveau code
+ driver_enable video_cards_nouveau nouveau
+
+ # ATI code
+ driver_enable video_cards_r100 radeon
+ driver_enable video_cards_r200 r200
+ if ! use video_cards_r100 && \
+ ! use video_cards_r200; then
+ driver_enable video_cards_radeon radeon r200
+ fi
+ fi
+
+ if use egl; then
+ myconf+="
+ --with-egl-platforms=x11$(use wayland && echo ",wayland")$(use gbm && echo ",drm")
+ $(use_enable gallium gallium-egl)
+ "
+ fi
+
+ if use gallium; then
+ myconf+="
+ $(use_enable g3dvl gallium-g3dvl)
+ $(use_enable llvm gallium-llvm)
+ $(use_enable openvg)
+ $(use_enable r600-llvm-compiler)
+ $(use_enable vdpau)
+ $(use_enable xvmc)
+ "
+ gallium_enable swrast
+ gallium_enable video_cards_vmware svga
+ gallium_enable video_cards_nouveau nouveau
+ gallium_enable video_cards_i915 i915
+ if ! use video_cards_i915; then
+ gallium_enable video_cards_intel i915
+ fi
+
+ gallium_enable video_cards_r300 r300
+ gallium_enable video_cards_r600 r600
+ gallium_enable video_cards_radeonsi radeonsi
+ if ! use video_cards_r300 && \
+ ! use video_cards_r600; then
+ gallium_enable video_cards_radeon r300 r600
+ fi
+ # opencl stuff
+ if use opencl; then
+ myconf+="
+ $(use_enable opencl)
+ --with-opencl-libdir="${EPREFIX}/usr/$(get_libdir)/OpenCL/vendors/mesa"
+ --with-libclc-path="${EPREFIX}/usr"
+ --with-clang-libdir="${EPREFIX}/usr/$(get_libdir)"
+ "
+ fi
+ fi
+
+ # x86 hardened pax_kernel needs glx-rts, bug 240956
+ if use pax_kernel; then
+ myconf+="
+ $(use_enable x86 glx-rts)
+ "
+ fi
+
+ use userland_GNU || export INDENT=cat
+
+ econf \
+ --enable-dri \
+ --enable-glx \
+ $(use_enable !bindist texture-float) \
+ $(use_enable debug) \
+ $(use_enable egl) \
+ $(use_enable gbm) \
+ $(use_enable gles1) \
+ $(use_enable gles2) \
+ $(use_enable nptl glx-tls) \
+ $(use_enable osmesa) \
+ $(use_enable !pic asm) \
+ $(use_enable shared-glapi) \
+ $(use_enable xa) \
+ $(use_enable xorg) \
+ --with-dri-drivers=${DRI_DRIVERS} \
+ --with-gallium-drivers=${GALLIUM_DRIVERS} \
+ ${myconf}
+}
+
+src_install() {
+ base_src_install
+
+ find "${ED}" -name '*.la' -exec rm -f {} + || die
+
+ if use !bindist; then
+ dodoc docs/patents.txt
+ fi
+
+ # Save the glsl-compiler for later use
+ if ! tc-is-cross-compiler; then
+ dobin "${S}"/src/glsl/glsl_compiler
+ fi
+
+ # Install config file for eselect mesa
+ insinto /usr/share/mesa
+ newins "${FILESDIR}/eselect-mesa.conf.8.1" eselect-mesa.conf
+
+ # Move libGL and others from /usr/lib to /usr/lib/opengl/blah/lib
+ # because user can eselect desired GL provider.
+ ebegin "Moving libGL and friends for dynamic switching"
+ local x
+ local gl_dir="/usr/$(get_libdir)/opengl/${OPENGL_DIR}/"
+ dodir ${gl_dir}/{lib,extensions,include/GL}
+ for x in "${ED}"/usr/$(get_libdir)/lib{EGL,GL*,OpenVG}.{la,a,so*}; do
+ if [ -f ${x} -o -L ${x} ]; then
+ mv -f "${x}" "${ED}${gl_dir}"/lib \
+ || die "Failed to move ${x}"
+ fi
+ done
+ for x in "${ED}"/usr/include/GL/{gl.h,glx.h,glext.h,glxext.h}; do
+ if [ -f ${x} -o -L ${x} ]; then
+ mv -f "${x}" "${ED}${gl_dir}"/include/GL \
+ || die "Failed to move ${x}"
+ fi
+ done
+ for x in "${ED}"/usr/include/{EGL,GLES*,VG,KHR}; do
+ if [ -d ${x} ]; then
+ mv -f "${x}" "${ED}${gl_dir}"/include \
+ || die "Failed to move ${x}"
+ fi
+ done
+ eend $?
+
+ if use classic || use gallium; then
+ ebegin "Moving DRI/Gallium drivers for dynamic switching"
+ local gallium_drivers=( i915_dri.so i965_dri.so r300_dri.so r600_dri.so swrast_dri.so )
+ keepdir /usr/$(get_libdir)/dri
+ dodir /usr/$(get_libdir)/mesa
+ for x in ${gallium_drivers[@]}; do
+ if [ -f "${S}/$(get_libdir)/gallium/${x}" ]; then
+ mv -f "${ED}/usr/$(get_libdir)/dri/${x}" "${ED}/usr/$(get_libdir)/dri/${x/_dri.so/g_dri.so}" \
+ || die "Failed to move ${x}"
+ insinto "/usr/$(get_libdir)/dri/"
+ if [ -f "${S}/$(get_libdir)/${x}" ]; then
+ insopts -m0755
+ doins "${S}/$(get_libdir)/${x}"
+ fi
+ fi
+ done
+ for x in "${ED}"/usr/$(get_libdir)/dri/*.so; do
+ if [ -f ${x} -o -L ${x} ]; then
+ mv -f "${x}" "${x/dri/mesa}" \
+ || die "Failed to move ${x}"
+ fi
+ done
+ pushd "${ED}"/usr/$(get_libdir)/dri || die "pushd failed"
+ ln -s ../mesa/*.so . || die "Creating symlink failed"
+ # remove symlinks to drivers known to eselect
+ for x in ${gallium_drivers[@]}; do
+ if [ -f ${x} -o -L ${x} ]; then
+ rm "${x}" || die "Failed to remove ${x}"
+ fi
+ done
+ popd
+ eend $?
+ fi
+ if use opencl; then
+ ebegin "Moving Gallium/Clover OpenCL implentation for dynamic switching"
+ if [ -f "${ED}/usr/$(get_libdir)/libOpenCL.so" ]; then
+ mv -f "${ED}"/usr/$(get_libdir)/libOpenCL.so* \
+ "${ED}"/usr/$(get_libdir)/OpenCL/vendors/mesa
+ fi
+ fi
+}
+
+pkg_postinst() {
+ # Switch to the xorg implementation.
+ echo
+ eselect opengl set --use-old ${OPENGL_DIR}
+
+ # switch to xorg-x11 and back if necessary, bug #374647 comment 11
+ OLD_IMPLEM="$(eselect opengl show)"
+ if [[ ${OPENGL_DIR}x != ${OLD_IMPLEM}x ]]; then
+ eselect opengl set ${OPENGL_DIR}
+ eselect opengl set ${OLD_IMPLEM}
+ fi
+
+ # Select classic/gallium drivers
+ if use classic || use gallium; then
+ eselect mesa set --auto
+ fi
+
+ # warn about patent encumbered texture-float
+ if use !bindist; then
+ elog "USE=\"bindist\" was not set. Potentially patent encumbered code was"
+ elog "enabled. Please see patents.txt for an explanation."
+ fi
+
+ local using_radeon r_flag
+ for r_flag in ${RADEON_CARDS}; do
+ if use video_cards_${r_flag}; then
+ using_radeon=1
+ break
+ fi
+ done
+
+ if [[ ${using_radeon} = 1 ]] && ! has_version media-libs/libtxc_dxtn; then
+ elog "Note that in order to have full S3TC support, it is necessary to install"
+ elog "media-libs/libtxc_dxtn as well. This may be necessary to get nice"
+ elog "textures in some apps, and some others even require this to run."
+ fi
+}
+
+# $1 - VIDEO_CARDS flag
+# other args - names of DRI drivers to enable
+# TODO: avoid code duplication for a more elegant implementation
+driver_enable() {
+ case $# in
+ # for enabling unconditionally
+ 1)
+ DRI_DRIVERS+=",$1"
+ ;;
+ *)
+ if use $1; then
+ shift
+ for i in $@; do
+ DRI_DRIVERS+=",${i}"
+ done
+ fi
+ ;;
+ esac
+}
+
+gallium_enable() {
+ case $# in
+ # for enabling unconditionally
+ 1)
+ GALLIUM_DRIVERS+=",$1"
+ ;;
+ *)
+ if use $1; then
+ shift
+ for i in $@; do
+ GALLIUM_DRIVERS+=",${i}"
+ done
+ fi
+ ;;
+ esac
+}